<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>DomainUserDetailsService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Test App J Hipster</a> &gt; <a href="index.source.html" class="el_package">com.theo.myjhipster.security</a> &gt; <span class="el_source">DomainUserDetailsService.java</span></div><h1>DomainUserDetailsService.java</h1><pre class="source lang-java linenums">package com.theo.myjhipster.security;

import com.theo.myjhipster.domain.User;
import com.theo.myjhipster.repository.UserRepository;
import org.hibernate.validator.internal.constraintvalidators.hv.EmailValidator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import java.util.stream.Collectors;

/**
 * Authenticate a user from the database.
 */
@Component(&quot;userDetailsService&quot;)
public class DomainUserDetailsService implements UserDetailsService {

<span class="fc" id="L25">    private final Logger log = LoggerFactory.getLogger(DomainUserDetailsService.class);</span>

    private final UserRepository userRepository;

<span class="fc" id="L29">    public DomainUserDetailsService(UserRepository userRepository) {</span>
<span class="fc" id="L30">        this.userRepository = userRepository;</span>
<span class="fc" id="L31">    }</span>

    @Override
    @Transactional
    public UserDetails loadUserByUsername(final String login) {
<span class="fc" id="L36">        log.debug(&quot;Authenticating {}&quot;, login);</span>

<span class="fc bfc" id="L38" title="All 2 branches covered.">        if (new EmailValidator().isValid(login, null)) {</span>
<span class="fc" id="L39">            return userRepository.findOneWithAuthoritiesByEmail(login)</span>
<span class="fc" id="L40">                .map(user -&gt; createSpringSecurityUser(login, user))</span>
<span class="fc" id="L41">                .orElseThrow(() -&gt; new UsernameNotFoundException(&quot;User with email &quot; + login + &quot; was not found in the database&quot;));</span>
        }

<span class="fc" id="L44">        String lowercaseLogin = login.toLowerCase(Locale.ENGLISH);</span>
<span class="fc" id="L45">        return userRepository.findOneWithAuthoritiesByLogin(lowercaseLogin)</span>
<span class="fc" id="L46">            .map(user -&gt; createSpringSecurityUser(lowercaseLogin, user))</span>
<span class="fc" id="L47">            .orElseThrow(() -&gt; new UsernameNotFoundException(&quot;User &quot; + lowercaseLogin + &quot; was not found in the database&quot;));</span>

    }

    private org.springframework.security.core.userdetails.User createSpringSecurityUser(String lowercaseLogin, User user) {
<span class="fc bfc" id="L52" title="All 2 branches covered.">        if (!user.getActivated()) {</span>
<span class="fc" id="L53">            throw new UserNotActivatedException(&quot;User &quot; + lowercaseLogin + &quot; was not activated&quot;);</span>
        }
<span class="fc" id="L55">        List&lt;GrantedAuthority&gt; grantedAuthorities = user.getAuthorities().stream()</span>
<span class="pc" id="L56">            .map(authority -&gt; new SimpleGrantedAuthority(authority.getName()))</span>
<span class="fc" id="L57">            .collect(Collectors.toList());</span>
<span class="fc" id="L58">        return new org.springframework.security.core.userdetails.User(user.getLogin(),</span>
<span class="fc" id="L59">            user.getPassword(),</span>
            grantedAuthorities);
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.2.201808211720</span></div></body></html>